;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=16F628A, r=DEC
#include <P16F628A.inc>
 __CONFIG _DATA_CP_OFF & _LVP_OFF & _MCLRE_OFF & _WDTE_OFF & _INTRC_OSC_NOCLKOUT

;********************************************************************************

;Set aside memory locations for variables
AUX	EQU	32
DADO	EQU	33
DADO_H	EQU	34
DIG0	EQU	35
DIG0A	EQU	36
DIG1	EQU	37
DIG1A	EQU	38
DIG2	EQU	39
DIG2A	EQU	40
DIG3	EQU	41
DIG3A	EQU	42
DIGCENT	EQU	43
DIGDEC	EQU	44
DLYMPX	EQU	45
DLYREAD	EQU	46
DLYREAD1	EQU	47
LE_MAX6675	EQU	48
LE_MAX6675_H	EQU	49
SYSBITVAR0	EQU	50
SYSBYTETEMPA	EQU	117
SYSBYTETEMPB	EQU	121
SYSBYTETEMPX	EQU	112
SYSDIVLOOP	EQU	116
SYSDIVMULTA	EQU	119
SYSDIVMULTA_H	EQU	120
SYSDIVMULTB	EQU	123
SYSDIVMULTB_H	EQU	124
SYSDIVMULTX	EQU	114
SYSDIVMULTX_H	EQU	115
SYSSTRINGA	EQU	119
SYSTEMP1	EQU	51
SYSTEMP1_H	EQU	52
SYSTEMP2	EQU	53
SYSTEMP3	EQU	54
SYSTEMP4	EQU	55
SYSWORDTEMPA	EQU	117
SYSWORDTEMPA_H	EQU	118
SYSWORDTEMPB	EQU	121
SYSWORDTEMPB_H	EQU	122
SYSWORDTEMPX	EQU	112
SYSWORDTEMPX_H	EQU	113
VALOR	EQU	56
VALOR1	EQU	58
VALOR1_H	EQU	59
VALOR_H	EQU	57
VEZ	EQU	60

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Automatic pin direction setting
	banksel	TRISB
	clrf	TRISB

;Start of the main program
;*******************************************************************************
;TERMMETRO C/ DISPLAYS DE 7 SEG (4 DGITOS)
;Para a faixa de: 0 - 1023,75 C (TERMOPAR TIPO 'K')
;Com PIC 16f628A e MAX 6675
;Autor: Claudio Larios
;Data: 26/06/2020
;Com 4 Displays de 7 seguimentos (opcionalmente ctodo ou nodo comum)
;ImportAnte: Use o esquema correto conforme a opo acima.
;Obs. Montagem de natureza didtica
;Este arquivo  parte integrante do blog Picsource
;*******************************************************************************/
;#define ANODO_COMUM
;Comente o acima para catodo comum e descomente para nodo comum
;=============================================================================/
;----- Configuraes
;#define  so       PORTA.7
;Dir so in
	bsf	TRISA,7
;#define  sck      PORTA.6
;Dir sck out
	bcf	TRISA,6
;#define  cs       PORTA.4
;Dir cs out
	bcf	TRISA,4
;#define on  1
;#define off 0
;constantes para converso 7 seguimentos
;PGFEDCBA   SEGUIMENTOS
;variveis globais
;Dim dig3 as byte: dig3 = 0
	banksel	DIG3
	clrf	DIG3
;Dim dig2 as byte: dig2 = 0
	clrf	DIG2
;Dim dig1 as byte: dig1 = 0
	clrf	DIG1
;Dim dig0 as byte: dig0 = 0
	clrf	DIG0
;Dim dig3a as byte: dig3a = 0
	clrf	DIG3A
;Dim dig2a as byte: dig2a = 0
	clrf	DIG2A
;Dim dig1a as byte: dig1a = 0
	clrf	DIG1A
;Dim dig0a as byte: dig0a = 0
	clrf	DIG0A
;Dim digdec as byte: digdec = 0
	clrf	DIGDEC
;Dim digcent as byte: digcent = 0
	clrf	DIGCENT
;Dim dlyread as byte: dlyread = 0
	clrf	DLYREAD
;Dim dlyread1 as byte: dlyread1 = 0
	clrf	DLYREAD1
;Dim dlympx as byte: dlympx = 0
	clrf	DLYMPX
;Dim vez as byte: vez = 0
	clrf	VEZ
;Dim aux as Byte
;Dim tmp1 as byte
;Dim tmp2 as byte
;Dim dado as word
;Dim waux as word
;Dim valor as word: valor = 0
	clrf	VALOR
	clrf	VALOR_H
;Dim fok as bit: fok = 0
	bcf	SYSBITVAR0,0
;Dim f_conv_ok as bit: f_conv_ok = 0 'flag de converso no realizada
	bcf	SYSBITVAR0,1
;Dim fsts as bit: fsts = 0'flag status 'existe sensor ou no ligado'
	bcf	SYSBITVAR0,2
;Dim fp1 as bit: fp1 = 0
	bcf	SYSBITVAR0,3
;Dim fp2 as bit: fp2 = 0
	bcf	SYSBITVAR0,4
;==============================================================================
;ROTINA MAIN
;==============================================================================
;CMCON = 7'desliga comparadores internos
	movlw	7
	movwf	CMCON
;TRISA = 0b10100000'sentido fixo das PORTAs
	movlw	160
	banksel	TRISA
	movwf	TRISA
;TRISB = 0'idem
	clrf	TRISB
;PORTA=PORTA AND 0xf0'desliga displays anodo ou catodo
	movlw	240
	banksel	PORTA
	andwf	PORTA,F
;cs = 1
	bsf	PORTA,4
;sck = 0
	bcf	PORTA,6
;==============================================================================
;LAO DE REPETIO PRINCIPAL
;==============================================================================
;DO
SysDoLoop_S1
;valor = le_max6675   'le sensor
	call	FN_LE_MAX6675
	movf	LE_MAX6675,W
	movwf	VALOR
	movf	LE_MAX6675_H,W
	movwf	VALOR_H
;mostra_nos_displays(valor)  'converte valores e apresenta nos displays
	movf	VALOR,W
	movwf	VALOR1
	movf	VALOR_H,W
	movwf	VALOR1_H
	call	MOSTRA_NOS_DISPLAYS
	movf	VALOR1,W
	movwf	VALOR
	movf	VALOR1_H,W
	movwf	VALOR_H
;multiplexa   'multiplexa os dgitos
	call	MULTIPLEXA
;LOOP
	goto	SysDoLoop_S1
SysDoLoop_E1
;******************************************************************************
;MULTIPLEXA OS DISPLAYS
;******************************************************************************/
;==============================================================================
;ROTINA DE LEITURA DOS DADOS DO MAX6675
;==============================================================================
;#define DELAY_ENTRE_CONVERCOES 50 '25 'Aprox. 0,5 seg
;==============================================================================
;ROTINA DE APRESENTAO DOS RESULTADOS NOS DISPLAYS DE 7 SEGUIMENTOS
;==============================================================================
;==============================================================================
;FIM DO PROGRAMA
;==============================================================================
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	movwf	CMCON
;Turn off all ports
;PORTA = 0
	clrf	PORTA
;PORTB = 0
	clrf	PORTB
	return

;********************************************************************************

FN_LE_MAX6675
;temporiza de forma dinmica os intervalos necessrios para a converso
;/mnimo 250 ms
;dlyread = dlyread + 1
	incf	DLYREAD,F
;if(dlyread <250)then
	movlw	250
	subwf	DLYREAD,W
	btfsc	STATUS, C
	goto	ELSE9_1
;exit function
	return
;else
	goto	ENDIF9
ELSE9_1
;dlyread=0
	clrf	DLYREAD
;dlyread1 = dlyread1 + 1
	incf	DLYREAD1,F
;if(dlyread1 < DELAY_ENTRE_CONVERCOES)then
	movlw	50
	subwf	DLYREAD1,W
	btfss	STATUS, C
;exit function
	return
;end if
;end if
ENDIF9
;dlyread1 = 0
	clrf	DLYREAD1
;inicia a comunicao com o Max6675
;dado = 0
	clrf	DADO
	clrf	DADO_H
;cs = 0
	bcf	PORTA,4
;for aux = 1 to 16     'le 16 bits
	clrf	AUX
SysForLoop1
	incf	AUX,F
;sck = 1 'clock=1
	bsf	PORTA,6
;dado = dado + dado  ' vezes 2 ou desloca para esquerda
	movf	DADO,W
	addwf	DADO,F
	movf	DADO_H,W
	btfsc	STATUS,C
	incfsz	DADO_H,W
	addwf	DADO_H,F
;if(so = 1) then
	btfsc	PORTA,7
;dado.0 = 1 '  seta bit0 de dado
	bsf	DADO,0
;end if
;sck = 0 'clock=0
	bcf	PORTA,6
;next
	movlw	16
	subwf	AUX,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;cs = 1;//libera para novas converes de temperatura
	bsf	PORTA,4
;if(dado.2 = 0) then
	btfsc	DADO,2
	goto	ELSE12_1
;fsts = 0 'termopar conectado corretamente
	bcf	SYSBITVAR0,2
;else
	goto	ENDIF12
ELSE12_1
;fsts = 1'termopar aberto ou desconectado
	bsf	SYSBITVAR0,2
;end if
ENDIF12
;desloca para direita 3 casas
;dado = dado / 8
	movf	DADO,W
	movwf	SysWORDTempA
	movf	DADO_H,W
	movwf	SysWORDTempA_H
	movlw	8
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DADO
	movf	SysWORDTempA_H,W
	movwf	DADO_H
;f_conv_ok = 1'sucesso na convero da temperatura
	bsf	SYSBITVAR0,1
;le_max6675 = dado ' retorna 'dado'
	movf	DADO,W
	movwf	LE_MAX6675
	movf	DADO_H,W
	movwf	LE_MAX6675_H
	return

;********************************************************************************

MOSTRA_NOS_DISPLAYS
;if(f_conv_ok = 0)then Exit Sub
	btfss	SYSBITVAR0,1
	return
;f_conv_ok = 0'se '1' ento  tem uma convero
	bcf	SYSBITVAR0,1
;digcent = 0
	clrf	DIGCENT
;digdec = 0
	clrf	DIGDEC
;if((valor1.1 = 1) and (valor1.0 = 1))then
	clrf	SysByteTempX
	btfsc	VALOR1,1
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp1
	clrf	SysByteTempX
	btfsc	VALOR1,0
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF16
;digdec = 7   'converte p/ valores corretos
	movlw	7
	movwf	DIGDEC
;digcent = 5
	movlw	5
	movwf	DIGCENT
;end if
ENDIF16
;if((valor1.1 = 0) and (valor1.0 = 1))then
	clrf	SysByteTempX
	btfss	VALOR1,1
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp1
	clrf	SysByteTempX
	btfsc	VALOR1,0
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF17
;digdec  = 5  'converte p/ valores corretos
	movlw	5
	movwf	DIGDEC
;digcent = 0
	clrf	DIGCENT
;end if
ENDIF17
;if((valor1.1 = 1) and (valor1.0 = 0))then
	clrf	SysByteTempX
	btfsc	VALOR1,1
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp1
	clrf	SysByteTempX
	btfss	VALOR1,0
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF18
;digdec  = 2  'converte p/ valores corretos
	movlw	2
	movwf	DIGDEC
;digcent = 5
	movlw	5
	movwf	DIGCENT
;end if
ENDIF18
;divide por 4 (lsb=0,25)
;valor1 = valor1 / 4
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	4
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	VALOR1
	movf	SysWORDTempA_H,W
	movwf	VALOR1_H
;if(valor1 >= 1000)then ' valores iguais ou acima de 1000 graus C
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	232
	movwf	SysWORDTempB
	movlw	3
	movwf	SysWORDTempB_H
	call	SysCompLessThan16
	comf	SysByteTempX,F
	btfss	SysByteTempX,0
	goto	ELSE19_1
;dig3a = valor1 / 1000 'converte para decimal nos dgitos auxiliares
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	232
	movwf	SysWORDTempB
	movlw	3
	movwf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG3A
;valor1 = valor1 % 1000
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	232
	movwf	SysWORDTempB
	movlw	3
	movwf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	VALOR1
	movf	SysWORDTempX_H,W
	movwf	VALOR1_H
;dig2a = valor1 / 100
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG2A
;valor1 = valor1 % 100
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	VALOR1
	movf	SysWORDTempX_H,W
	movwf	VALOR1_H
;dig1a = valor1 / 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG1A
;dig0a = valor1 % 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	DIG0A
;fp2 = 0 'desliga ponto do dgito 2
	bcf	SYSBITVAR0,4
;fp1 = 0 'desliga ponto do dgito 1
	bcf	SYSBITVAR0,3
;else
	goto	ENDIF19
ELSE19_1
;if(valor1 >= 100)then 'valores iguais ou acima de 100 graus C
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompLessThan16
	comf	SysByteTempX,F
	btfss	SysByteTempX,0
	goto	ELSE21_1
;dig3a = valor1 / 100
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG3A
;valor1 = valor1 % 100
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	VALOR1
	movf	SysWORDTempX_H,W
	movwf	VALOR1_H
;dig2a = valor1 / 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG2A
;dig1a = valor1 % 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	DIG1A
;dig0a = digdec
	movf	DIGDEC,W
	movwf	DIG0A
;fp1 = 1 'liga ponto do dgito 1
	bsf	SYSBITVAR0,3
;fp2 = 0
	bcf	SYSBITVAR0,4
;else 'valores abaixo de 100 graus C
	goto	ENDIF21
ELSE21_1
;dig3a = valor1 / 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	DIG3A
;dig2a = valor1 % 10
	movf	VALOR1,W
	movwf	SysWORDTempA
	movf	VALOR1_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempX,W
	movwf	DIG2A
;dig1a = digdec
	movf	DIGDEC,W
	movwf	DIG1A
;dig0a = digcent
	movf	DIGCENT,W
	movwf	DIG0A
;fp1 = 0'desliga ponto
	bcf	SYSBITVAR0,3
;fp2 = 1'liga ponto do dgito 2
	bsf	SYSBITVAR0,4
;end if
ENDIF21
;end if
ENDIF19
;if(fsts = 1)then 'verifica se o termopar est interrompido ou desconectado
	btfss	SYSBITVAR0,2
	goto	ENDIF20
;dig3a = 10'  'n' envia mensagem 'noSE'
	movlw	10
	movwf	DIG3A
;dig2a = 11'  'o'
	movlw	11
	movwf	DIG2A
;dig1a = 5'   'S'
	movlw	5
	movwf	DIG1A
;dig0a = 12'  'E'
	movlw	12
	movwf	DIG0A
;fp1 = 0' desliga ponto
	bcf	SYSBITVAR0,3
;fp2 = 0' desliga ponto do dgito 2
	bcf	SYSBITVAR0,4
;end if
ENDIF20
;fok = 1  'avisa multiplexagem que tem uma leitura nova
	bsf	SYSBITVAR0,0
	return

;********************************************************************************

MULTIPLEXA
;dlympx = dlympx + 1
	incf	DLYMPX,F
;if(dlympx < 2)then exit sub;//multiplexa 1 em cada 3 vezes
	movlw	2
	subwf	DLYMPX,W
	btfss	STATUS, C
	return
;dlympx = 0
	clrf	DLYMPX
;if(fok=1)then
	btfss	SYSBITVAR0,0
	goto	ENDIF2
;dig0 = dig0a
	movf	DIG0A,W
	movwf	DIG0
;dig1 = dig1a
	movf	DIG1A,W
	movwf	DIG1
;dig2 = dig2a
	movf	DIG2A,W
	movwf	DIG2
;dig3 = dig3a
	movf	DIG3A,W
	movwf	DIG3
;fok = 0
	bcf	SYSBITVAR0,0
;end if
ENDIF2
;vez = vez + 1
	incf	VEZ,F
;if( vez > 3)then vez = 0
	movf	VEZ,W
	sublw	3
	btfss	STATUS, C
	clrf	VEZ
;PORTA = PORTA AND 0xf0;//apaga display (resetando)
	movlw	240
	andwf	PORTA,F
#IFNDEF
;PORTB = 0
	clrf	PORTB
#ENDIF
;Select Case vez
;case 0:
SysSelect1Case1
	movf	VEZ,F
	btfss	STATUS, Z
	goto	SysSelect1Case2
;aux = dig3 + 1
	incf	DIG3,W
	movwf	AUX
;ReadTable num, aux, PORTB
	movwf	SYSSTRINGA
	call	NUM
	movwf	PORTB
;if dig3 > 0 then PORTA = PORTA OR 8 'apaga zeros a esquerda
	movf	DIG3,W
	sublw	0
	btfsc	STATUS, C
	goto	ENDIF4
	movlw	8
	iorwf	PORTA,F
ENDIF4
;Case 1:
	goto	SysSelectEnd1
SysSelect1Case2
	decf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;aux = dig2 + 1
	incf	DIG2,W
	movwf	AUX
;ReadTable num, aux, PORTB
	movwf	SYSSTRINGA
	call	NUM
	movwf	PORTB
;if(fp2 = 1)then PORTB = PORTB or 0X80 ' testa se deve acender ponto
	btfss	SYSBITVAR0,4
	goto	ENDIF5
	movlw	128
	iorwf	PORTB,F
ENDIF5
;if ((dig3 > 0) OR (dig2 > 0 ))then PORTA = PORTA OR 4 'apaga zeros a esquerda
	movf	DIG3,W
	movwf	SysBYTETempB
	clrf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp1
	movf	DIG2,W
	movwf	SysBYTETempB
	clrf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	iorwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF6
	movlw	4
	iorwf	PORTA,F
ENDIF6
;Case 2:
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;aux = dig1 + 1
	incf	DIG1,W
	movwf	AUX
;ReadTable num, aux, PORTB
	movwf	SYSSTRINGA
	call	NUM
	movwf	PORTB
;if(fp1 = 1)then PORTB = PORTB or 0X80 ' testa se deve acender ponto
	btfss	SYSBITVAR0,3
	goto	ENDIF7
	movlw	128
	iorwf	PORTB,F
ENDIF7
;if ((dig3 > 0) OR (dig2 > 0 ) OR (dig1 > 0 ))then PORTA = PORTA OR 2 'apaga zeros a esquerda
	movf	DIG3,W
	movwf	SysBYTETempB
	clrf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp1
	movf	DIG2,W
	movwf	SysBYTETempB
	clrf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	DIG1,W
	movwf	SysBYTETempB
	clrf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp3
	movf	SysTemp1,W
	iorwf	SysTemp2,W
	movwf	SysTemp4
	iorwf	SysTemp3,W
	movwf	SysTemp1
	btfss	SysTemp1,0
	goto	ENDIF8
	movlw	2
	iorwf	PORTA,F
ENDIF8
;Case 3:
	goto	SysSelectEnd1
SysSelect1Case4
	movlw	3
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelectEnd1
;aux = dig0 + 1
	incf	DIG0,W
	movwf	AUX
;ReadTable num, aux, PORTB
	movwf	SYSSTRINGA
	call	NUM
	movwf	PORTB
;PORTA = PORTA OR 1
	movlw	1
	iorwf	PORTA,F
;End Select
SysSelectEnd1
	return

;********************************************************************************

NUM
	movlw	14
	subwf	SysStringA, W
	btfsc	STATUS, C
	retlw	0
	movf	SysStringA, W
	addlw	low TableNUM
	movwf	SysStringA
	movlw	high TableNUM
	btfsc	STATUS, C
	addlw	1
	movwf	PCLATH
	movf	SysStringA, W
	movwf	PCL
TableNUM
	retlw	13
	retlw	63
	retlw	6
	retlw	91
	retlw	79
	retlw	102
	retlw	109
	retlw	125
	retlw	7
	retlw	127
	retlw	111
	retlw	84
	retlw	92
	retlw	121

;********************************************************************************

SYSCOMPEQUAL16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;Test low, exit if false
;movf SysWordTempA, W
	movf	SYSWORDTEMPA, W
;subwf SysWordTempB, W
	subwf	SYSWORDTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;Test high, exit if false
;movf SysWordTempA_H, W
	movf	SYSWORDTEMPA_H, W
;subwf SysWordTempB_H, W
	subwf	SYSWORDTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W
;subwf SysByteTempA, W
	subwf	SYSBYTETEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;Test High, exit if more
;movf SysWordTempA_H,W
	movf	SYSWORDTEMPA_H,W
;subwf SysWordTempB_H,W
	subwf	SYSWORDTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;Test high, exit true if less
;movf SysWordTempB_H,W
	movf	SYSWORDTEMPB_H,W
;subwf SysWordTempA_H,W
	subwf	SYSWORDTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;Test Low, exit if more or equal
;movf SysWordTempB,W
	movf	SYSWORDTEMPB,W
;subwf SysWordTempA,W
	subwf	SYSWORDTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysWordTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysWordTempA
	movf	SYSWORDTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSWORDTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysWordTempB
	movf	SYSWORDTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSWORDTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;Avoid division by zero
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysWORDTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysWORDTempA_H
	clrf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompEqual16
	btfss	SysByteTempX,0
	goto	ENDIF22
;SysWordTempA = 0
	clrf	SYSWORDTEMPA
	clrf	SYSWORDTEMPA_H
;exit sub
	return
;end if
ENDIF22
;Main calc routine
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	incfsz	SYSDIVMULTB_H,W
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF23
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	incfsz	SYSDIVMULTB_H,W
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF23
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysWordTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSWORDTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSWORDTEMPA_H
;SysWordTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSWORDTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSWORDTEMPX_H
	return

;********************************************************************************


 END
